package top.imwork.window.silos.controller.cms.books;

import jakarta.annotation.Resource;
import jakarta.validation.Valid;
import org.springframework.web.bind.annotation.*;

import top.imwork.commons.core.base.BaseController;
import top.imwork.commons.core.pojo.DeleteParams;
import top.imwork.commons.core.pojo.ResponseMsg;
import top.imwork.window.silos.convert.ContentsConvert;
import top.imwork.window.silos.pojo.bo.ContentsBO;
import top.imwork.window.silos.pojo.bo.ContentsResultBO;
import top.imwork.window.silos.pojo.po.ContentsListParamVO;
import top.imwork.window.silos.pojo.po.ContentsParamVO;
import top.imwork.window.silos.service.book.IContentsService;

/**
 * 图书内容表
 *
 * @author jiangxiaowei
 * email: e-jiangxiaowei@outlook.com
 * date: 2025-11-04 17:46:32
 */
@RestController
@RequestMapping("/cms/book/contents")
public class ContentsServiceController extends BaseController {

    @Resource
    public IContentsService contentsService;

    /**
     * 根据id查询数据
     * @param id long类型的id
     * @return 返回查询结果
     */
    @GetMapping("/info/{id}")
    public ResponseMsg info(@PathVariable("id") Long id){
        return ResponseMsg.buildResponse(contentsService.info(id));
    }

    /**
     * 新增/修改info
     * @param contentsParamVO 实体信息
     * @return responseMsg 操作结果
     */
    @PostMapping("/save")
    public ResponseMsg save(@RequestBody @Valid ContentsParamVO contentsParamVO){
        ContentsBO contentsBO = contentsService.save(ContentsConvert.contentsParamVoToDto(contentsParamVO));
        return ResponseMsg.buildResponse(ContentsConvert.contentsBoToVo(contentsBO));
    }

    /**
     * 根据id删除图书内容表
     * @param id id
     * @return true/false 成功/失败
     */
    @DeleteMapping("/delete/{id}")
    public ResponseMsg delete(@PathVariable("id") Long id){
        return contentsService.delete(id)? ResponseMsg.ok() : ResponseMsg.fail();
    }

    /**
     * 批量逻辑删除信息
     *
     * @param dto 删除条件
     * @return true/false 是否删除成功
     */
    @DeleteMapping("/deleteByIds")
    public ResponseMsg deleteByIds(@RequestBody DeleteParams dto){
        String[] idArr = dto.getIds().split(",");
        return contentsService.deleteByIds(idArr)? ResponseMsg.ok() : ResponseMsg.fail();
    }

    @PostMapping("/queryPage")
    public ResponseMsg queryPage(@RequestBody @Valid ContentsListParamVO contentsListParamVO) {
        ContentsResultBO contentsResultBO = contentsService.queryPage(ContentsConvert.contentsListParamVoToDTO(contentsListParamVO));
        return ResponseMsg.buildResponse(ContentsConvert.contentsResultBoToVo(contentsResultBO));
    }
}
